-- [[CONSOLE VARIABLES]]
rawset(_G, "cv_weather_increment", CV_RegisterVar({
    name = "weathermod_increment",
    defaultvalue = 15, --12
    flags = CV_NETVAR,
    PossibleValue = {MIN = 1, MAX = 99}
}))

rawset(_G, "cv_weather_decrement", CV_RegisterVar({
    name = "weathermod_decrement",
    defaultvalue = 15, --12
    flags = CV_NETVAR,
    PossibleValue = {MIN = 1, MAX = 99}
}))

rawset(_G, "cv_weather_maxtime", CV_RegisterVar({
    name = "weathermod_maxtime",
    defaultvalue = 9999, --9999
    flags = CV_NETVAR,
    PossibleValue = {MIN = 1000, MAX = 99999}
}))

rawset(_G, "cv_weather_hellchance", CV_RegisterVar({
    name = "weathermod_hell",
    defaultvalue = 5, --9999
    flags = CV_NETVAR,
    PossibleValue = {MIN = 0, MAX = 100}
}))

rawset(_G, "cv_weathermod", CV_RegisterVar({
    name = "weathermod",
    defaultvalue = 1,
    flags = CV_NETVAR,
    PossibleValue = {Off = 0, On = 1}
}))

rawset(_G, "cv_weathermod_encore", CV_RegisterVar({
    name = "weathermod_encore",
    defaultvalue = 1,
    flags = CV_NETVAR,
    PossibleValue = {Off = 0, On = 1, force=2}
}))

rawset(_G, "cv_weathermod_order", CV_RegisterVar({
    name = "weathermod_order",
    defaultvalue = 0,
    flags = CV_NETVAR,
    PossibleValue = {Off = 0, On = 1}
}))

rawset(_G, "cv_weathermod_keepforced", CV_RegisterVar({
    name = "weathermod_keepforced",
    defaultvalue = 0,
    flags = CV_NETVAR,
    PossibleValue = {Off = 0, On = 1}
}))

COM_AddCommand("weathermod_force", function(server, pattern)
    --print(pattern)
    local result = nil

    if (pattern == nil) print("Specify a weather you want to force"); return end

    -- match the name in the list of weathers
    for _,i in pairs(weathermod.weatherlist) do
		result = string.match(string.lower(i.name), string.lower(pattern))
        if result ~= nil result = i break end -- if one name matchs it takes the table
    end
    -- -- UNCOMMENT ONLY FOR HELL WEATHERS DEBUGING
    -- for _,i in pairs(weathermod.weatherhell) do
	-- 	result = string.match(string.lower(i.name), string.lower(pattern))
    --     if result ~= nil result = i break end -- if one name matchs it takes the table
    -- end
	--print(result.value)
    if result and mapheaderinfo[gamemap].removeweather and string.match(mapheaderinfo[gamemap].removeweather, string.lower(result.name))
        print("Weather is restricted by the level header")

    elseif result and weathermod.levelbanweather and string.match(weathermod.levelbanweather, string.lower(result.name))
        print("Weather is restricted by the level header")

    elseif cv_weathermod.value == 0
        print("Weathermod is disabled")

    elseif result ~= nil and weathermod.active == true -- forced weather is already active
        weathermod.active = false
        weathermod.timerW = cv_weather_maxtime.value
        weathermod.forceActive = false
        print("Weather was already active, type again")

         -- [Mountain case] renable hidden hud elements
         hud.enable("item")
         
        
    elseif result ~= nil -- match found, weather will be active
        weathermod.current = result
        weathermod.previous = result
        weathermod.active = true
        weathermod.timerW = 1
        weathermod.forceActive = true
        print("forced weather to " + weathermod.current.name)

    else -- no match found, aka result is nil
        print("no match found")
        weathermod.active = false
        weathermod.timerW = cv_weather_maxtime.value
        weathermod.forceActive = false
        -- [Mountain case] renable hidden hud elements
        hud.enable("item")
    end
end, 1)


--[[VARIABLES]]
rawset(_G, "weathermod", {
    
    timerW = 0,
    active = false,
    forceActive = false,
    levelbanweather = nil,

    current = nil,
    previous = nil,
   
    weatherlist = {
        {id = 1, name = "Sunny", color = 101, centerX = 16, desc = "Higher top speed", encore = "EVEN higher top speed"},
        {id = 2, name = "Snowy", color = 126, centerX = 17, desc = "Slippery track", encore = "Ice skating time"},
        {id = 3, name = "Earthquake", color = 116, centerX = 30, desc = "Bouncy items", encore = "Higher bouncing item"},
        {id = 4, name = "Lunar", color = 121, centerX = 17, desc = "Low gravity", encore = "No gravity on items", nobattle = true},
        {id = 5, name = "Dimension", color = 136, centerX = 26, desc = "Growing", encore = "Bigger growing"},
        {id = 6, name = "Typhoon", color = 121, centerX = 22, desc = "Immune to hazards", encore = "No flashtics", nobattle = true},
        {id = 7, name = "Windy", color = 136, centerX = 16, desc = "Air time charges boost", encore = "Air time charges MORE boost"},
        {id = 8, name = "Sunset", color = 106, centerX = 19, desc = "Stylish drifting", encore = "Real gamer drifting"},
        {id = 9, name = "Twinkle star", color = 101, centerX = 36, desc = "Double item pickups", encore = "Triple item pickups"},
        {id = 10, name = "Rain", color = 121, centerX = 14, desc = "Lose item/powerup on hit", encore = "Gain item on hit", nobattle = true},
        {id = 11, name = "Tempest", color = 131, centerX = 22, desc = "Jumping spinout", encore = "Jumping bumps"},
        {id = 12, name = "Thunderstorm", color = 121, centerX = 38, desc = "Thundershock on spinout", encore = "Gain thunder shield anytime"},
        {id = 13, name = "Blood moon", color = 116, centerX = 29, desc = "Wipe out racers on bump", encore = "Steal items on bump"},
        {id = 14, name = "Mountain vapor", color = 131, centerX = 45, desc = "Hidden item slot", encore = "Use quickly your item"},
        {id = 15, name = "Sandstorm", color = 106, centerX = 26, desc = "Faster drift sparks", encore = "No drift sparks"},
        {id = 16, name = "Cloudy", color = 136, centerX = 19, desc = "Single item type", encore = "Rare item only"},
        {id = 17, name = "Blue sky", color = 126, centerX = 22, desc = "Strange driving", encore = "Nothing happens"},
        {id = 18, name = "Aurora", color = 106, centerX = 19, desc = "Grant boost from hits", encore = "Grant invincibility from hits"},
        {id = 19, name = "Night", color = 121, centerX = 17, desc = "Screen is darker", encore = "Can you see somthing?"},
        {id = 20, name = "Pressure", color = 131, centerX = 25, desc = "The fastest squashs", encore = "Items can squash"},
        {id = 21, name = "Hail", color = 126, centerX = 13, desc = "Things fall from sky", encore = "MANY things fall from sky"},
        {id = 22, name = "Comet", color = 101, centerX = 17, desc = "Bigger items", encore = "More big items"},
    },

    weatherhell = {
        --{id = 90, name = "clear", color = 22, centerX = 16, desc = "Nothing happens", encore = "Nothing happens"},
        {id = 91, name = "Shrink", color = 22, centerX = 18, desc = "Synch Failure", encore = "Synch Failure"},
        {id = 92, name = "Toy kingdom", color = 22, centerX = 34, desc = "Boing! Boing! Boing!", encore = "Boing! Boing! Boing!"},
        {id = 93, name = "Parallel Universe", color = 22, centerX = 46, desc = "Drift presses become A presses", encore = "Drift presses become A presses"},
        {id = 94, name = "Sink rain", color = 22, centerX = 24, desc = "It's danmaku time!", encore = "It's danmaku time!"},
        {id = 95, name = "Disaster", color = 22, centerX = 24, desc = "Everything is random", encore = "Everything is random"},
        {id = 96, name = "Superstar", color = 22, centerX = 26, desc = "Go fast", encore = "Go fast"},
    },

    delay = 0,
    lasttime = 0,

    Cloudychooseitem = nil,
    Disasterpick = {weather = nil, effect = nil},

})

------------------------------------------------------------------------------------------------
addHook("ThinkFrame", function()
    if weathermod.active == true and cv_weathermod.value
        -- weather functions
        for player in players.iterate do
            -- this must be run for all players in race, spectators or empty nodes has no mobj
            if player.valid and not player.spectator
                --
                if weathermod.current.id == 1
                        --print("sun")
                        P_SwitchWeather(0) -- weathermod num
                        P_SetupLevelSky(88) -- Sky from a level

                        --give boost, except on offroad
                        if player.kartstuff[k_offroad] == 0
                            if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                             (cv_weathermod_encore.value == 2) player.kartstuff[k_boostpower] = FRACUNIT + FRACUNIT/2
                            else player.kartstuff[k_boostpower] = FRACUNIT + FRACUNIT/3
                            end 
                        end

                        -- astetic effect on boost
                        if player.kartstuff[k_invincibilitytimer] != 0
                        elseif player.kartstuff[k_sneakertimer] > 0 and leveltime%3 == 0
                            player.mo.color = 47
                            player.mo.colorized = true
                        else 
                            player.mo.color = player.skincolor
                            player.mo.colorized = false
                        end
                --
                elseif weathermod.current.id == 2
                        --print("snowy")
                        P_SwitchWeather(2) -- weathermod num
                        P_SetupLevelSky(55) -- Sky from a level

                        if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                             (cv_weathermod_encore.value == 2)  player.mo.friction = FRACUNIT
                        else player.mo.friction = FRACUNIT - FRACUNIT/600
                        end 
                --
                elseif weathermod.current.id == 3
                    if replayplayback == false P_StartQuake(300000, 10) end -- earthquake
                --
                elseif weathermod.current.id == 4
                        --print("lunar")

                        P_SwitchWeather(0) -- weathermod num
                        P_SetupLevelSky(1017) -- Sky from a level
                        
                        -- lower gravity when player is not on ground
                        if not P_IsObjectOnGround(player.mo)
                            if (player.mo.eflags & MFE_UNDERWATER) -- case for underwater
                                P_SetObjectMomZ(player.mo, (gravity/2)/2, true)
                            else
                                P_SetObjectMomZ(player.mo, gravity/2, true)
                            end
                        end
                --
                elseif weathermod.current.id == 5
                    -- NOTICE: the weather dosen't work in shrink-grow base
                        --print("Dimension")
                        
                        P_SwitchWeather(0) -- weathermod num
                        P_SetupLevelSky(12) -- Sky from a level

                            
                            -- scale doesn't reset normally, the reset will happen in the else weathermod.active condition
                            if (encoremode == true and cv_weathermod_encore.value == 1) or
                             (cv_weathermod_encore.value == 2) player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*2)-100 -- 199% (ENCORE MODE)
                            else player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*3)/2 -- 150%
                            end

                            if player.kartstuff[k_growshrinktimer] >= 1 -- if the grow item is used
                                if (encoremode == true and cv_weathermod_encore.value == 1) or
                                 (cv_weathermod_encore.value == 2) player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*5)/2 -- 250% (ENCORE MODE)
                                else player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*2)-100 -- (199%)
                                end
                            elseif player.kartstuff[k_growshrinktimer] <= -1 -- if the shrink item is used
                                if (encoremode == true and cv_weathermod_encore.value == 1) or
                                 (cv_weathermod_encore.value == 2) player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*2)-100 -- 199% (ENCORE MODE)
                                else player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale) -- (100%)
                                end
                            else
                            end
                --
                elseif weathermod.current.id == 6
                        --print("typhoon")
                        P_SwitchWeather(0) -- weathermod num
                        P_SetupLevelSky(87) -- Sky from a level

                        -- trigger flashing
                        if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                         (cv_weathermod_encore.value == 2) player.powers[pw_flashing] = 0 
                        else player.powers[pw_flashing] = 10
                        end
                --
                elseif weathermod.current.id == 7
                        --print("Windy")
                        --P_SwitchWeather(0) -- weathermod num
                        P_SetupLevelSky(31) -- Sky from a level
                        
                        -- lose all boost on spinout or respawn
                        if player.kartstuff[k_spinouttimer] ~= 0 or player.kartstuff[k_respawn] ~= 0
                            player.Windyaircharge = 0
                        end

                        -- unleash boost
                        if P_IsObjectOnGround(player.mo) and player.kartstuff[k_spinouttimer] == 0 and player.kartstuff[k_respawn] == 0
                            if player.Windyaircharge > 35 -- airtime = one second
                                -- astetic effect
                                if player.kartstuff[k_invincibilitytimer] != 0
                                elseif player.Windyaircharge%3 == 0 player.mo.color = 1
                                else player.mo.color = player.skincolor end
                                -- boost effect
                                K_DoSneaker(player)
                                -- reduce charge time
                                player.Windyaircharge = $ - 2
                            end
                            if player.Windyaircharge > 0 and player.Windyaircharge <= 35  -- airtime less than one second
                                -- astetic effect
                                if player.kartstuff[k_invincibilitytimer] != 0
                                elseif player.Windyaircharge%3 == 0 player.mo.color = 1
                                else player.mo.color = player.skincolor end
                                P_SpawnGhostMobj(player.mo)
                                -- boost effect
                                player.kartstuff[k_speedboost] = FRACUNIT + FRACUNIT/4
                                player.kartstuff[k_accelboost] = FRACUNIT
                                -- reduce charge time
                                player.Windyaircharge = $ - 2
                            end

                        else -- charge boost
                            if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                             (cv_weathermod_encore.value == 2) player.Windyaircharge = $ + 2
                            else player.Windyaircharge = $ + 1 end
                            player.mo.color = player.skincolor -- prevent the player staying to another color while in air
                        end
                --
                elseif weathermod.current.id == 8
                        --print("Sunset")

                        P_SwitchWeather(0) -- weathermod num
                        P_SetupLevelSky(4733) -- Sky from a level

                        -- when the player drift, gives some boost
                        if player.kartstuff[k_drift] ~= 0 and player.kartstuff[k_offroad] == 0
                            if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                             (cv_weathermod_encore.value == 2) player.kartstuff[k_speedboost] = FRACUNIT + FRACUNIT/2; player.kartstuff[k_accelboost] = FRACUNIT
                            else player.kartstuff[k_speedboost] = FRACUNIT + FRACUNIT/3
                            end 
                        end

                        -- astetic effect on drift
                        if player.kartstuff[k_invincibilitytimer] != 0 or player.kartstuff[k_offroad] != 0
                        elseif player.kartstuff[k_drift] ~= 0 and leveltime%3 == 0 
                        player.mo.color = 34
                        player.mo.colorized = true
                        else 
                            player.mo.color = player.skincolor
                            player.mo.colorized = false
                        end
                --
                elseif weathermod.current.id == 9
                        --print("twinkle")

                        P_SwitchWeather(0) -- weathermod num
                        P_SetupLevelSky(8) -- Sky from a level

                        -- did the player already recived the item before?
                        -- so we gave him double amount
                        if player.kartstuff[k_itemtype] ~= 0 and player.TwinklegotDouble == false
                            if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                             (cv_weathermod_encore.value == 2) player.kartstuff[k_itemamount] = $ * 3
                            else player.kartstuff[k_itemamount] = $ * 2 
                            end 
                            player.TwinklegotDouble = true -- prevent repeat this function
                        
                        -- when the player used/lost the item, allow him to double on next pickup
                        elseif player.kartstuff[k_itemtype] == 0
                            player.TwinklegotDouble = false
                        end
                --
                elseif weathermod.current.id == 10
                        --print("rain")

                        P_SwitchWeather(3) -- weathermod num
                        P_SetupLevelSky(11) -- Sky from a level

                        
                        -- remove item when spinout, squished or instashield (does during invinc or flashing)
                        if player.kartstuff[k_spinouttimer] >= 50 or player.kartstuff[k_squishedtimer] >= 1 or player.kartstuff[k_instashield] >= 1
                            if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                             (cv_weathermod_encore.value == 2)
                                if player.kartstuff[k_itemtype] == 0 player.kartstuff[k_itemroulette] = 35 end
                            else
                                -- item roulette
                                player.kartstuff[k_itemtype] = 0 -- remove item
                                player.kartstuff[k_itemamount] = 0 -- also remove item
                                player.kartstuff[k_eggmanexplode] = 0 -- cancels eggman explosion timer
                                if player.kartstuff[k_roulettetype] ~= 2 player.kartstuff[k_itemroulette] = 0 end -- cancels roulette

                                -- powerups
                                player.powers[pw_flashing] = 0 -- cancels flashing
                                player.kartstuff[k_hyudorotimer] = 0 -- cancels hyudoro
                                if player.kartstuff[k_growshrinktimer] > 1 player.kartstuff[k_growshrinktimer] = 1 end -- cancels grow
                                player.kartstuff[k_rocketsneakertimer] = 0 -- cancels rocket sneakers
                                if player.kartstuff[k_invincibilitytimer] > 1 player.kartstuff[k_invincibilitytimer] = 1 end -- cancels invincibility	
                            end
                        end
                --
                elseif weathermod.current.id == 11
                        --print("tempest")
                        P_SwitchWeather(1) -- weathermod num
                        P_SetupLevelSky(75) -- Sky from a level
                        
                        if P_IsObjectOnGround(player.mo) and player.kartstuff[k_spinouttimer] >= 50 and encoremode == false
                            P_SetObjectMomZ(player.mo, FRACUNIT*20, false)

                        elseif player.kartstuff[k_spinouttimer] ~= 0 and encoremode == false
                            player.kartstuff[k_spinouttimer] = $ - 1
                        end
                --
                elseif weathermod.current.id == 12
                        --print("thunder")
                        P_SwitchWeather(5) -- weathermod num
                        P_SetupLevelSky(28) -- Sky from a level

                        if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                         (cv_weathermod_encore.value == 2)
                            if leveltime%105 == 1 and player.kartstuff[k_itemtype] == 0 and player.kartstuff[k_itemamount] == 0 and P_RandomChance(FRACUNIT/3)
                            -- 33% of chance to get a thunder shield every 3 seconds
                            player.kartstuff[k_itemtype] = KITEM_THUNDERSHIELD
                            player.kartstuff[k_itemamount] = 1
                            --player.kartstuff[k_curshield] = 1
                            end
                        else
                            -- remeber the last item get
                            if player.kartstuff[k_itemtype] ~= 0 and player.kartstuff[k_itemtype] ~= KITEM_THUNDERSHIELD and player.kartstuff[k_itemheld] == 0
                                player.Thunderlastitem = {item = player.kartstuff[k_itemtype], amount = player.kartstuff[k_itemamount]}
                                --print(player.Thunderlastitem.item)
                            -- on spin out, player item will be replaced by thunder shield, so this condition will gave the previous item get
                            elseif player.Thunderlastitem and player.kartstuff[k_spinouttimer] >= 50
                                player.kartstuff[k_itemtype] = player.Thunderlastitem.item
                                player.kartstuff[k_itemamount] = player.Thunderlastitem.amount
                                --print("aaaa")
                            else -- no items, so set the last item to nil
                                --print("non") 
                                player.Thunderlastitem = nil
                            end
                        end
                --
                elseif weathermod.current.id == 13
                        --print("bloodmoon")
                        P_SwitchWeather(0) -- weathermod num
                        P_SetupLevelSky(105) -- Sky from a level
                --
                elseif weathermod.current.id == 14
                    --print("Mountain")
                    P_SwitchWeather(0) -- weathermod num
                    P_SetupLevelSky(2517) -- Sky from a level

                    -- disables the HUD, it will be reenabled in the weathermod.lua
                    if replayplayback == false
                        hud.disable("item")
                    end
                    if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                     (cv_weathermod_encore.value == 2)
                        if player.mountainDrop >= TICRATE*3 
                        K_DropItems(player)
                        player.mountainDrop = 0
                        end

                        if player.kartstuff[k_itemtype] ~= 0 and player.kartstuff[k_itemheld] == 0
                            player.mountainDrop = $ + 1
                        else player.mountainDrop = 0
                        end
                        
                    end

                --  
                elseif weathermod.current.id == 15
                    --print("sand")
                    P_SwitchWeather(0) -- weathermod num
                    P_SetupLevelSky(3262) -- Sky from a level

                    if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                     (cv_weathermod_encore.value == 2) player.kartstuff[k_driftcharge] = 0
                    else if P_IsObjectOnGround(player.mo) player.kartstuff[k_driftcharge] = $ + 33 end 
                    end
                --
                elseif weathermod.current.id == 16
                    --print("cloud")
                    local itempicked
                    P_SwitchWeather(0) -- weathermod num
                    P_SetupLevelSky(10) -- Sky from a level
                    
                    if not (weathermod.Cloudychooseitem) weathermod.Cloudychooseitem = P_RandomKey(6) end

                    -- pick an item type witch depends to the randomKey result
                    if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                     (cv_weathermod_encore.value == 2)
                        if weathermod.Cloudychooseitem == 1 itempicked = KITEM_ROCKETSNEAKER
                        elseif weathermod.Cloudychooseitem == 2 itempicked = KITEM_INVINCIBILITY
                        elseif weathermod.Cloudychooseitem == 3 itempicked = KITEM_GROW
                        elseif weathermod.Cloudychooseitem == 4 itempicked = KITEM_HYUDORO
                        elseif weathermod.Cloudychooseitem == 5 itempicked = KITEM_POGOSPRING
                        else itempicked = KITEM_KITCHENSINK end
                    else
                        if weathermod.Cloudychooseitem == 1 itempicked = KITEM_BANANA
                        elseif weathermod.Cloudychooseitem == 2 itempicked = KITEM_ORBINAUT
                        elseif weathermod.Cloudychooseitem == 3 itempicked = KITEM_JAWZ
                        elseif weathermod.Cloudychooseitem == 4 itempicked = KITEM_BALLHOG
                        elseif weathermod.Cloudychooseitem == 5 itempicked = KITEM_SNEAKER
                        else itempicked = KITEM_KITCHENSINK end
                    end

                    -- change the amount depending the item type
                    -- J'espere que personne va me juger avec ce code
                    if not (encoremode == true and cv_weathermod_encore.value == 1) or not --[[ENCORE MODE VARIANT]]
                     (cv_weathermod_encore.value == 2)
                    if player.kartstuff[k_itemtype] == KITEM_BANANA and player.kartstuff[k_itemheld] == 0

                        if player.kartstuff[k_itemamount] == 1 -- simple banana
                            if itempicked == KITEM_BANANA -- no change
                            elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 1
                            elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 1
                            elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 1
                            elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 1
                            else                                    player.kartstuff[k_itemamount] = 1
                            end
                        elseif player.kartstuff[k_itemamount] >= 10 -- decabanana or more
                            if itempicked == KITEM_BANANA -- no change
                            elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 5
                            elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 3
                            elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 3
                            elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 3
                            else                                    player.kartstuff[k_itemamount] = 1
                            end
                        elseif player.kartstuff[k_itemamount] >= 2 -- between 2 and 9 bananas
                            if itempicked == KITEM_BANANA -- no change
                            elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 2
                            elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 2
                            elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 2
                            elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 2
                            else                                    player.kartstuff[k_itemamount] = 1
                            end
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_ORBINAUT and player.kartstuff[k_itemheld] == 0

                        if player.kartstuff[k_itemamount] == 1 -- simple orbi
                            if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 1 
                            elseif itempicked == KITEM_ORBINAUT     -- no change
                            elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 1
                            elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 1
                            elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 1
                            else                                    player.kartstuff[k_itemamount] = 1
                            end
                        elseif player.kartstuff[k_itemamount] >= 4 -- quad orbi or more
                            if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 6
                            elseif itempicked == KITEM_ORBINAUT     -- no change
                            elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 3
                            elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 3
                            elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 3
                            else                                    player.kartstuff[k_itemamount] = 1
                            end
                        elseif player.kartstuff[k_itemamount] >= 2 -- 2 or 3 orbis
                            if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 3
                            elseif itempicked == KITEM_ORBINAUT     -- no change
                            elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 2
                            elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 2
                            elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 2
                            else                                    player.kartstuff[k_itemamount] = 1
                            end
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_JAWZ and player.kartstuff[k_itemheld] == 0

                        if player.kartstuff[k_itemamount] == 1 -- simple jawz
                            if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 3
                            elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 2
                            elseif itempicked == KITEM_JAWZ         -- no change
                            elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 1
                            elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 1
                            else                                    player.kartstuff[k_itemamount] = 1
                            end
                        elseif player.kartstuff[k_itemamount] >= 2 -- double jawz or more
                            if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 5
                            elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 4
                            elseif itempicked == KITEM_JAWZ         -- no change
                            elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 2
                            elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 2
                            else                                    player.kartstuff[k_itemamount] = 1
                            end
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_SPB and player.kartstuff[k_itemheld] == 0

                        if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 5
                        elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 4
                        elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 3
                        elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 2
                        elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 5
                        else                                    player.kartstuff[k_itemamount] = 1
                        end
                    
                    elseif player.kartstuff[k_itemtype] == KITEM_BALLHOG and player.kartstuff[k_itemheld] == 0

                        if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 3
                        elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 2
                        elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 1
                        elseif itempicked == KITEM_BALLHOG      -- no change
                        elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 1
                        else                                    player.kartstuff[k_itemamount] = 1
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_EGGMAN and player.kartstuff[k_itemheld] == 0

                        if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 1
                        elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 1
                        elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 1
                        elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 1
                        elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 1
                        else                                    player.kartstuff[k_itemamount] = 1
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_MINE and player.kartstuff[k_itemheld] == 0

                        if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 4
                        elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 3
                        elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 2
                        elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 1
                        elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 2
                        else                                    player.kartstuff[k_itemamount] = 1
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_SNEAKER and player.kartstuff[k_itemheld] == 0

                        if player.kartstuff[k_itemamount] == 1 -- simple sneaker
                            if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 3
                            elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 2
                            elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 1
                            elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 1
                            elseif itempicked == KITEM_SNEAKER      -- no change
                            else                                    player.kartstuff[k_itemamount] = 1
                            end
                        elseif player.kartstuff[k_itemamount] >= 3 -- triple sneaker or more
                            if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 6
                            elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 4
                            elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 2
                            elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 3
                            elseif itempicked == KITEM_SNEAKER       -- no change
                            else                                    player.kartstuff[k_itemamount] = 1
                            end
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_ROCKETSNEAKER and player.kartstuff[k_itemheld] == 0

                        if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 8
                        elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 6
                        elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 5
                        elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 5
                        elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 5
                        else                                    player.kartstuff[k_itemamount] = 1
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_INVINCIBILITY and player.kartstuff[k_itemheld] == 0

                        if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 10
                        elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 8
                        elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 6
                        elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 5
                        elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 6
                        else                                    player.kartstuff[k_itemamount] = 1
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_GROW and player.kartstuff[k_itemheld] == 0

                        if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 10
                        elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 8
                        elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 6
                        elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 5
                        elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 6
                        else                                    player.kartstuff[k_itemamount] = 1
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_HYUDORO and player.kartstuff[k_itemheld] == 0

                        if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 6
                        elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 4
                        elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 3
                        elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 3
                        elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 3
                        else                                    player.kartstuff[k_itemamount] = 1
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_THUNDERSHIELD and player.kartstuff[k_itemheld] == 0

                        if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 2
                        elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 2
                        elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 1
                        elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 1
                        elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 1
                        else                                    player.kartstuff[k_itemamount] = 1
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_POGOSPRING and player.kartstuff[k_itemheld] == 0

                        if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 4
                        elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 2
                        elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 1
                        elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 1
                        elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 1
                        else                                    player.kartstuff[k_itemamount] = 1
                        end

                    elseif player.kartstuff[k_itemtype] == KITEM_SHRINK and player.kartstuff[k_itemheld] == 0

                        if itempicked == KITEM_BANANA           player.kartstuff[k_itemamount] = 25
                        elseif itempicked == KITEM_ORBINAUT     player.kartstuff[k_itemamount] = 14
                        elseif itempicked == KITEM_JAWZ         player.kartstuff[k_itemamount] = 10
                        elseif itempicked == KITEM_BALLHOG      player.kartstuff[k_itemamount] = 9
                        elseif itempicked == KITEM_SNEAKER      player.kartstuff[k_itemamount] = 10
                        else                                    player.kartstuff[k_itemamount] = 1
                        end

                    end
                    end


                    -- change the item type to the itempicked value
                    if player.kartstuff[k_itemtype] ~= itempicked and player.kartstuff[k_itemheld] == 0
                        player.kartstuff[k_itemblinkmode] = 1
                        player.kartstuff[k_itemtype] = itempicked
                    end
                --
                elseif weathermod.current.id == 17
                    --print("sky")
                    P_SwitchWeather(0) -- weathermod num
                    P_SetupLevelSky(42) -- Sky from a level

                    if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                     (cv_weathermod_encore.value == 2) return end -- nothing will happen in encore mode
                     
                    player.kartstuff[k_drift] = 0
                    player.kartstuff[k_accelboost] = FRACUNIT*100
                --
                elseif weathermod.current.id == 18
                    --print("aurora")
                    P_SwitchWeather(0) -- weathermod num
                    P_SetupLevelSky(90) -- Sky from a level
                --
                elseif weathermod.current.id == 19
                    --print("night")
                    --P_SwitchWeather(0) -- weathermod num
                    P_SetupLevelSky(118) -- Sky from a level
                --
                elseif weathermod.current.id == 20
                    --print("pressure")
                    --P_SwitchWeather(0) -- weathermod num
                    P_SetupLevelSky(3388) -- Sky from a level

                    -- make player vunerable to squish on land if spinning
                    if encoremode == false and player.kartstuff[k_spinouttimer] > 0 and not P_IsObjectOnGround(player.mo)
                        player.PressureArial = true
                    end
                    -- [[ENCORE MODE VARIANT]]
                    if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                     (cv_weathermod_encore.value == 2)
                        if player.kartstuff[k_spinouttimer] > 0 and P_IsObjectOnGround(player.mo)
                            player.kartstuff[k_spinouttimer] = 0
                            player.kartstuff[k_squishedtimer] = 70
                        end
                    end

                    if player.PressureArial == true and P_IsObjectOnGround(player.mo)
                        player.kartstuff[k_squishedtimer] = 35
                        player.PressureArial = false
                    end
                --
                elseif weathermod.current.id == 21
                    --print("hail")
                    P_SwitchWeather(2) -- weathermod num
                    P_SetupLevelSky(76) -- Sky from a level

                    local rockrate = 13 + player.kartstuff[k_position]

                    if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
                     (cv_weathermod_encore.value == 2)
                        if leveltime%rockrate == 1
                        P_SpawnMobj(player.mo.x+FRACUNIT*P_SignedRandom()*8,
                         player.mo.y+FRACUNIT*P_SignedRandom()*8,
                         player.mo.z+FRACUNIT*500,
                         MT_FALLINGROCK) end
                    else 
                        if leveltime%(rockrate/2) == 1
                        P_SpawnMobj(player.mo.x+FRACUNIT*P_SignedRandom()*8,
                         player.mo.y+FRACUNIT*P_SignedRandom()*8,
                         player.mo.z+FRACUNIT*500,
                         MT_FALLINGROCK) end
                    end
                --
                elseif weathermod.current.id == 22
                    --print("comet")
                    P_SwitchWeather(0) -- weathermod num
                    P_SetupLevelSky(99) -- Sky from a level
                --




                --
                -- [[HELL]]
                --
                elseif weathermod.current.id == 90
                    local function activeClear(player) -- none
                        --print("clear")
                        

                    end
                    activeClear(player)
                --
                elseif weathermod.current.id == 91
                        --print("shrink")
                        --P_SwitchWeather(0) -- weathermod num
                        P_SetupLevelSky(93) -- Sky from a level

                        

                        -- scale doesn't reset normally, the reset will happen in the else weathermod.active condition
                        player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale/2) -- 50%
                        
                        if player.kartstuff[k_growshrinktimer] >= 1 -- if the grow item is used
                            player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale) -- 100%
                           
                        elseif player.kartstuff[k_growshrinktimer] <= -1 -- if the shrink item is used
                            player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale/3) -- 33%
                        else
                        end
                --  
                elseif weathermod.current.id == 92
                        --print("toy")
                        P_SwitchWeather(0) -- weathermod num
                        P_SetupLevelSky(89) -- Sky from a level

                        -- reproduce the pogospring effect
                        if P_IsObjectOnGround(player.mo) player.kartstuff[k_pogospring] = 1; K_DoPogoSpring(player.mo, 32<<FRACBITS, 1) end
                --
                elseif weathermod.current.id == 93
                        --print("aaa")
                        P_SwitchWeather(0) -- weathermod num
                        P_SetupLevelSky(30) -- Sky from a level

                        -- only triggers on button pressed, not hold
                    if ((player.cmd.buttons & BT_DRIFT) and P_IsObjectOnGround(player.mo) and player.Paralleljump == false) 
                        P_SetObjectMomZ(player.mo, FRACUNIT*8, false) 
                        player.Paralleljump = true
                    end
                    -- if the button got relased
                    if not (player.cmd.buttons & BT_DRIFT) player.Paralleljump = false end
                --
                elseif weathermod.current.id == 94
                        --print("sink")
                        P_SwitchWeather(3) -- weathermod num
                        --P_SetupLevelSky(30) -- Sky from a level
                        if leveltime%3 == 1
                         P_SpawnMobj(player.mo.x+FRACUNIT*P_SignedRandom()*12,
                         player.mo.y+FRACUNIT*P_SignedRandom()*12,
                         player.mo.z+FRACUNIT*500,
                         MT_SINK) 
                        end
                --
                elseif weathermod.current.id == 95 -- random
                    if weathermod.Disasterpick.weather == nil
                        weathermod.Disasterpick.weather = P_RandomKey(7)
                        P_SwitchWeather(weathermod.Disasterpick.weather) -- weathermod num
                    end

                    -- item roulette random
                    if player.kartstuff[k_itemtype] ~= 0 and player.kartstuff[k_itemheld] == 0
                        -- set the amount of items to 1
                        if player.kartstuff[k_itemamount] > 1 player.kartstuff[k_itemamount] = 1 end
                        player.kartstuff[k_itemtype] = P_RandomRange(1, 16)
                    end

                    -- orbinaut spawn random
                    if leveltime%35 == 1 and player.kartstuff[k_position] == 1
                         P_SpawnMobj(player.mo.x+FRACUNIT*P_SignedRandom()*20,
                         player.mo.y+FRACUNIT*P_SignedRandom()*20,
                         player.mo.z+FRACUNIT*700,
                         MT_ORBINAUT) 
                    end

                    
                    -- effect random
                    if weathermod.Disasterpick.effect == nil
                        weathermod.Disasterpick.effect = P_RandomKey(6)
                        print(weathermod.Disasterpick.effect)
                    elseif weathermod.Disasterpick.effect == 0 -- pick sunny

                        if player.kartstuff[k_offroad] == 0 player.kartstuff[k_boostpower] = FRACUNIT + FRACUNIT/3 end

                    elseif weathermod.Disasterpick.effect == 1 -- pick snowy

                        player.mo.friction = FRACUNIT - FRACUNIT/600

                    elseif weathermod.Disasterpick.effect == 2 -- pick dimension

                        player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*3)/2 -- 150%
                        if player.kartstuff[k_growshrinktimer] >= 1 -- if the grow item is used
                            player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*2)-100 -- (199%)
                        elseif player.kartstuff[k_growshrinktimer] <= -1 -- if the shrink item is used
                            player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale) -- (100%)    
                        else end

                    elseif weathermod.Disasterpick.effect == 3 -- pick sandstorm

                        if P_IsObjectOnGround(player.mo) player.kartstuff[k_driftcharge] = $ + 33 end 

                    elseif weathermod.Disasterpick.effect == 4 -- pick tempest
                        if P_IsObjectOnGround(player.mo) and player.kartstuff[k_spinouttimer] >= 50
                            P_SetObjectMomZ(player.mo, FRACUNIT*20, false)
                        end
                        if player.kartstuff[k_spinouttimer] ~= 0 player.kartstuff[k_spinouttimer] = $ - 1 end

                    elseif weathermod.Disasterpick.effect == 5 -- pick mountain vapor
                        if replayplayback == false
                            hud.disable("item")
                        end
                    end
                --
                elseif weathermod.current.id == 96 -- super fast
                    player.kartstuff[k_sneakertimer] = 4
                    player.kartstuff[k_growshrinktimer] = 4
                    player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*5)/2 -- 250%
                    player.kartstuff[k_invincibilitytimer] = 4
                end
            end
        end
    end
end)



----------------------------------------------------------------------------------------------------------
-- weathers that affect mobjects
local kartitem = {MT_BANANA, MT_ORBINAUT, MT_JAWZ, MT_JAWZ_DUD, MT_SSMINE, MT_SSMINE_SHIELD, MT_BALLHOG, MT_EGGMANITEM}
for _,i in pairs(kartitem) do
addHook("MobjThinker", function(mobj)
    if weathermod.active == true and cv_weathermod.value
    --
        if weathermod.current.id == 3 -- earthquake
            local vertical = 0
            if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
             (cv_weathermod_encore.value == 2) vertical = P_RandomRange(5, 50)
            else vertical = P_RandomRange(10, 20) -- bounce height will be random
            end 
            if P_IsObjectOnGround(mobj)
                P_SetObjectMomZ(mobj, FRACUNIT*vertical, false)
            end
            --activeEarthquake()
            --for i in pairs(kartitem) -- affect only kart items
            --    if mobj.type == kartitem[i] activeEarthquake(mobj) end
            -- end
        end
    -- [[ENCORE MODE VARIANT]]
        if weathermod.current.id == 4 -- low gravity
        if (encoremode == true and cv_weathermod_encore.value == 1) or
         (cv_weathermod_encore.value == 2)
            --print("lunar")
            
            if not P_IsObjectOnGround(mobj)
                if (mobj.eflags & MFE_UNDERWATER) -- case for underwater
                    P_SetObjectMomZ(mobj, 0, false)
                else
                    P_SetObjectMomZ(mobj, 0, false)
                end
            end

            -- for i in pairs(kartitem) -- affect only kart items
            --     if mobj.type == kartitem[i] activeLunarObject(mobj) end
            -- end
        end
        end

    end
end, i)
end


----------------------------------------------------------------------------
-- blood moon and pressure collisions
local function Playercollision(mo, mo2)
    if cv_weathermod.value
    if (mo.z + mo.height >= mo2.z) and (mo.z <= mo2.z + mo2.height) 
    -- blood moon
    if weathermod.current.id == 13 and weathermod.active == true
        -- must be players
        if not (mo.player) and (mo.valid) return end
		if not (mo2.player) and (mo2.valid) return end
        if (mo.type ~= MT_PLAYER and mo2.type ~= MT_PLAYER) return end

        -- conditions to make the opposant spinout
        if (mo.player.speed >= (mo2.player.speed*5)/4)
            if (mo.player.kartstuff[k_spinouttimer] > 0) -- not already spining
             or (mo2.player.kartstuff[k_spinouttimer] > 0)
             or (mo.player.powers[pw_flashing] > 0) -- not flashing
             or (mo2.player.powers[pw_flashing] > 0)
             or (mo.player.speed <= FRACUNIT*10) return end -- minimum speed
            --print("too fast")
            K_SpinPlayer(mo2.player, mo, 1, mo, false)
            if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
             (cv_weathermod_encore.value == 2) 
                if mo.player.kartstuff[k_itemtype] == 0 and mo.player.kartstuff[k_itemamount] == 0 and mo.player.kartstuff[k_itemroulette] == 0
                -- attacker steal victim slot
                mo.player.kartstuff[k_itemtype] = mo2.player.kartstuff[k_itemtype]
                mo.player.kartstuff[k_itemamount] = mo2.player.kartstuff[k_itemamount]
                -- empty vicitm slot
                mo2.player.kartstuff[k_itemtype] = 0
                mo2.player.kartstuff[k_itemamount] = 0
                end
            end
        end
    -- tempest [[ENCORE MODE VARIANT]]
    elseif weathermod.current.id == 11 and weathermod.active == true
        if (encoremode == true and cv_weathermod_encore.value == 1) or
         (cv_weathermod_encore.value == 2)
        --must be players
        if not (mo.player) and (mo.valid) return end
		if not (mo2.player) and (mo2.valid) return end
        if (mo.type ~= MT_PLAYER and mo2.type ~= MT_PLAYER) return end

        if P_IsObjectOnGround(mo)
            P_SetObjectMomZ(mo, FRACUNIT*20, false)
        end
        end
    
    -- pressure
    elseif weathermod.current.id == 20 and weathermod.active == true
        -- must be players
        if not (mo.player) and (mo.valid) return end
		if not (mo2.player) and (mo2.valid) return end
        if (mo.type ~= MT_PLAYER and mo2.type ~= MT_PLAYER) return end

        if (mo.player.speed < mo2.player.speed)
         if (mo.player.powers[pw_flashing] > 0) -- not flashing
         or (mo2.player.powers[pw_flashing] > 0)
         or (mo.player.kartstuff[k_growshrinktimer] > 0)
         or (mo.player.kartstuff[k_invincibilitytimer] > 0) return end
            if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
             (cv_weathermod_encore.value == 2) mo.player.kartstuff[k_squishedtimer] = 50
            else mo.player.kartstuff[k_squishedtimer] = 17 end
        end
    end
    end
    end
end
-- weathers that triggers on collision
addHook("MobjCollide", Playercollision, MT_PLAYER)
addHook("MobjMoveCollide", Playercollision, MT_PLAYER)



--------------------------------------------------------------------------------------------------
-- weather that triggers on players attacks
local function activeHit(victim, mo2, source) -- spinout
    -- thuderstorm
    if weathermod.active == true and cv_weathermod.value and weathermod.current.id == 12 and encoremode == false
        --print("thunder")
        -- item will be swapped by the thunder shield
        victim.kartstuff[k_curshield] = 1
        victim.kartstuff[k_itemtype] = KITEM_THUNDERSHIELD
        victim.kartstuff[k_itemamount] = 1
    
    -- Aurora
    elseif weathermod.active == true and cv_weathermod.value and weathermod.current.id == 18 and mo2 ~= nil
        
        if source.player == victim or source.player == nil return end -- does nothing on self hit
        if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
         (cv_weathermod_encore.value == 2) source.player.kartstuff[k_invincibilitytimer] = $ + TICRATE*2
        else K_DoSneaker(source.player) end -- boost on hit

    else return end
end

local function activeExplose(victim, mo2, source) -- explode
    -- thunderstorm
    if weathermod.active == true and cv_weathermod.value and weathermod.current.id == 12 and encoremode == false
        --print("thunder")
        K_DropItems(victim)
        victim.Thunderlastitem = nil
        victim.kartstuff[k_itemtype] = 0
        victim.kartstuff[k_itemamount] = 0

    -- Aurora
    elseif weathermod.active == true and cv_weathermod.value and weathermod.current.id == 18 and source.player and mo2 ~= nil
        --print("aurora")
        if source.player == victim or mo2 == nil return end -- does nothing on self hit
        if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
         (cv_weathermod_encore.value == 2) source.player.kartstuff[k_invincibilitytimer] = $ + TICRATE*2
        else K_DoSneaker(source.player) end

    else return end
end

local function activeSquish(victim, mo2, source) -- squished
    -- Aurora
    if weathermod.active == true and cv_weathermod.value and weathermod.current.id == 18 and source.player and mo2 ~= nil
        --print("aurora")
        if source.player == victim return end -- does nothing on self hit
        if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
         (cv_weathermod_encore.value == 2) source.player.kartstuff[k_invincibilitytimer] = $ + TICRATE*2
        else K_DoSneaker(source.player) end -- boost on hit

    else return end
end

-- hooks from the code above
addHook("PlayerSpin", activeHit)
addHook("PlayerExplode", activeExplose)
addHook("PlayerSquish", activeSquish)

-- hook for hail rain
addHook("MobjSpawn", function(mobj)
if weathermod.current.id == 21 and weathermod.active == true
    mobj.color = 72
    mobj.colorized = true
end
end, MT_FALLINGROCK)

local attackitem = {MT_BANANA, MT_ORBINAUT, MT_JAWZ, MT_JAWZ_DUD, MT_SSMINE, MT_BALLHOG, MT_SPB}
for _,i in pairs(attackitem) do
addHook("MobjSpawn", function(mobj)
    if weathermod.current.id == 22 and weathermod.active == true
        mobj.scalespeed = FRACUNIT/6
        if (encoremode == true and cv_weathermod_encore.value == 1) or --[[ENCORE MODE VARIANT]]
         (cv_weathermod_encore.value == 2)
            mobj.destscale = (mapheaderinfo[gamemap].mobj_scale*3)
        else mobj.destscale = (mapheaderinfo[gamemap].mobj_scale*2) end
    end
end, i)
end



--------------------------------------------
-- sync vars for multiplayer
addHook("NetVars", function(net)
    weathermod = net($)
end)