
freeslot("sfx_whspc1", "sfx_whspc2", "sfx_whspc3", "sfx_whspc4", "sfx_whspc5")


local gotremoved = nil
-- changing weather
local function changeWeather()
    if weathermod.active == true return end
    if weathermod.delay ~= 0 return end
    -- set delay to avoid too short changes (and no jiggles of the hud on start)
    weathermod.delay = 16
    -- if weathermod_order is on
    if cv_weathermod_order.value == 1 and weathermod.current
        if (weathermod.current.id == #weathermod.weatherlist) weathermod.current = weathermod.weatherlist[1]
        elseif (weathermod.current.id >= 90) weathermod.current = weathermod.weatherlist[1]
        else weathermod.current = weathermod.weatherlist[weathermod.current.id + 1] end
    else -- pick a random weather
        local gotremoved = nil
        if G_BattleGametype() -- battle condition, disables some weathers
            repeat -- with this loop, the weather always change to a different one
                weathermod.current = weathermod.weatherlist[P_RandomKey(#weathermod.weatherlist) + 1]
                if mapheaderinfo[gamemap].removeweather -- if the level header specified some wheathers to ban
                    gotremoved = string.match(mapheaderinfo[gamemap].removeweather, string.lower(weathermod.current.name))
                end  -- also no wheathers that match the lua.removeweather SOC line
                if weathermod.levelbanweather != nil -- vanilla maps ban
                    gotremoved = string.match(weathermod.levelbanweather, string.lower(weathermod.current.name))
                end
            until weathermod.current ~= weathermod.previous and gotremoved == nil and not weathermod.current.nobattle
        else -- normal race condition
            repeat 
                weathermod.current = weathermod.weatherlist[P_RandomKey(#weathermod.weatherlist) + 1]
                if mapheaderinfo[gamemap].removeweather 
                    gotremoved = string.match(mapheaderinfo[gamemap].removeweather, string.lower(weathermod.current.name))
                end
                if weathermod.levelbanweather != nil
                    gotremoved = string.match(weathermod.levelbanweather, string.lower(weathermod.current.name))
                end  -- also no wheathers that match the lua.removeweather SOC line
            until weathermod.current ~= weathermod.previous and gotremoved == nil
        end

        -- for hell weathers
        local hellnum = P_RandomKey(100)
        if hellnum < cv_weather_hellchance.value
            weathermod.current = weathermod.weatherhell[P_RandomKey(#weathermod.weatherhell) + 1]
        end
    end
    weathermod.previous = weathermod.current
end


-- pick only items that does wipeout
local function wipeoutHit(victim, mo2)
    if mo2 == nil return end
    
    if mo2.type == MT_ORBINAUT
    or mo2.type == MT_ORBINAUT_SHIELD
    or mo2.type == MT_JAWZ
    or mo2.type == MT_JAWZ_DUD
    or mo2.type == MT_JAWZ_SHIELD
    or mo2.type == MT_PLAYER and mo2.player.kartstuff[k_invincibilitytimer] >= 1
        changeWeather()
    end
end


local TwinklegotDouble = true -- Variable used for twinkle star weather
local Windyaircharge = 0 -- Variable used for windy weather
local Thunderlastitem = nil -- Variable used for Thunderstorm weather
local Paralleljump = false -- Variable used for Parallel universe weather
local PressureArial = false -- Variable used for pressure weather
local mountainDrop = 0 -- Variable used for mountain vapor weather

-- hardcoded remove weathers for vanilla maps
local nolunar = {["7"]=true, ["29"]=true, ["36"]=true, ["41"]=true, ["49"]=true, ["51"]=true, ["55"]=true, ["352"]=true, ["354"]=true, ["356"]=true, ["357"]=true, ["361"]=true, ["362"]=true}
local nowindy = {["7"]=true, ["41"]=true, ["49"]=true, ["51"]=true, ["357"]=true, ["361"]=true, ["362"]=true}
local nodimension = {["10"]=true, ["12"]=true, ["49"]=true, ["360"]=true}
local nosnowy = {["55"]=true}

--------------------------------------------------
-- init values when map is loaded
addHook("MapChange", function(themap)
    if cv_weathermod.value -- main toggle

    -- set the list of bans
    weathermod.levelbanweather = nil

    if nolunar[tostring(themap)] weathermod.levelbanweather = $ + "lunar " end
    if nowindy[tostring(themap)] weathermod.levelbanweather = $ + "windy " end
    if nodimension[tostring(themap)] weathermod.levelbanweather = $ + "dimension " end
    if nosnowy[tostring(themap)] weathermod.levelbanweather = $ + "snowy " end

    -- set default weather vars
    weathermod.timerW = cv_weather_maxtime.value
    weathermod.active = false
    if (weathermod.forceActive == false or cv_weathermod_keepforced.value == 0) weathermod.forceActive = false; changeWeather() end
    weathermod.delay = 0
    weathermod.lasttime = 0
    weathermod.previous = weathermod.current
    
    -- New var on player userdata
    for player in players.iterate do
        player.TwinklegotDouble = true 
        player.Windyaircharge = 0
        player.Thunderlastitem = nil
        player.Paralleljump = false
        player.PressureArial = false
        player.mountainDrop = 0
    end

    -- [Mountain case] renable hidden hud elements
    hud.enable("item")

    -- get default value for disabled events
    P_SwitchWeather(mapheaderinfo[themap].weather)
    P_SetupLevelSky(mapheaderinfo[themap].skynum)
    end
end)

--------------------------------------------------
-- main thinkframe
addHook("ThinkFrame", function()
    if cv_weathermod.value -- main toggle

    -- if current has no weather yet
    if (weathermod.current == nil) weathermod.current = weathermod.weatherlist[1] end
    if weathermod.forceActive == true weathermod.timerW = 0+1 end

    -- [[When the race starts]]
    if leveltime > 6*TICRATE + (3*TICRATE/4)
        
        ---------------------
        -- weather activated
        ---------------------
        if weathermod.active == true 
            -- timer increment
            weathermod.timerW = $ + cv_weather_increment.value
			
			-- astetics when the weather is about to end
            if weathermod.timerW >= cv_weather_maxtime.value-(cv_weather_increment.value*140) and weathermod.forceActive == false
                weathermod.lasttime = $ + 1
                if weathermod.lasttime%35 == 0 S_StartSound(nil, sfx_whspc3) end
            else weathermod.lasttime = 0
            end

            -- Will turn off weather
            -- weather reachs MAXTIME
            if weathermod.timerW >= cv_weather_maxtime.value
                weathermod.active = false
                weathermod.lasttime = 0

                -- Prevent players getting the weather astetic color when it ends
                for player in players.iterate do
                    if player.valid and not player.spectator
                        player.mo.color = player.skincolor
                        player.mo.colorized = false
                    end
                end

                 -- [Mountain case] renable hidden hud elements
                 hud.enable("item")

                --for player in players.iterate do COM_BufInsertText(player, "skybox off") end
                S_StartSound(nil, sfx_whspc2) -- burst sound
                weathermod.timerW = cv_weather_maxtime.value
                weathermod.delay = 0 -- fix weather didn't changing if the weather change before activation
                changeWeather() -- automaticly changes weather
            end

            local playcount = 0
            for player in players.iterate do
                if player.valid and not player.spectator
                    playcount = $ + 1
                end
            end

            if playcount == 0 and weathermod.forceActive == false weathermod.timerW = cv_weather_maxtime.value; weathermod.active = false  end

            -- [shrink & superstar case] doubles the time speed, making this weather shorter
            if weathermod.current.id == 91 weathermod.timerW = $ + cv_weather_increment.value end
            if weathermod.current.id == 96 weathermod.timerW = $ + cv_weather_increment.value end

        -------------------
        -- weather disabled
        -------------------
        else 
             -- timer decrement
            weathermod.timerW = $ - cv_weather_decrement.value
            P_SwitchWeather(mapheaderinfo[gamemap].weather)
            P_SetupLevelSky(mapheaderinfo[gamemap].skynum)
            
            -- Will turn on weather
            -- weather reachs zero activate the event
            if weathermod.timerW <= 0 
                weathermod.active = true
                S_StartSound(nil, sfx_whspc1) -- spell card sound
                if weathermod.current.id >= 90 S_StartSound(nil, sfx_whspc4) end -- alert on hell weather
                weathermod.timerW = 0
            end

            -- astetics when the weather is gonna start
            if weathermod.timerW <= 0+cv_weather_decrement.value*50 and weathermod.lasttime == 0
                weathermod.lasttime = 1
                S_StartSound(nil, sfx_whspc5)
            end

            -- decrase the delay after changing weather
            if weathermod.delay ~= 0 weathermod.delay = $ - 1 end
            local playcount = 0
            -- Note: players.iterate concatenate more the values for each player in this loop
            for player in players.iterate do
                if player.valid and not player.spectator
                    playcount = $ + 1
                    -- [Pressure case] disable vulnerability to pressure
                    player.PressureArial = false

                    -- [Twinkle star case] this avoid getting double amount item if twinkle star is picked again
                    player.TwinklegotDouble = true

                    -- [Windy case] this remove all the boost charged
                    player.Windyaircharge = 0

                    -- [Cloudy case] reset item picked by the weather
                    weathermod.Cloudychooseitem = nil

                    -- [Dimension case] this make sure grow will still work when dimension is disabled or didn't came out yet
                    if player.kartstuff[k_growshrinktimer] == 0
                        player.mo.destscale = mapheaderinfo[gamemap].mobj_scale
                    elseif player.kartstuff[k_growshrinktimer] <= -1 -- if shrink is used during dimension
                        player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*3)/4 -- (75%)
                    end

                    -- [Montain vapor case] reset timer of the item held in encore mode
                    player.mountainDrop = 0

                    -- [Disaster case] reset random values
                    weathermod.Disasterpick.weather = nil
                    weathermod.Disasterpick.effect = nil
                end
                
            end
            if playcount == 0 weathermod.timerW = $ + cv_weather_decrement.value end
        end 
    end
    end
end)

-- hooks that changes weather
addHook("PlayerSpin", wipeoutHit)
addHook("PlayerExplode", changeWeather)
addHook("PlayerSquish", changeWeather)